{% extends '@DemosPlanCore/DemosPlanCore/base.html.twig' %}

{% block component_part %}
    {% apply spaceless %}
        <h2 class="u-mt">
            {{ 'organisations.type'|trans }}
        </h2>

        <table class="c-table">
            <colgroup>
                <col>
                <col class="width-40">
            </colgroup>
            <thead>
            <tr>
                <th>{{ 'organisations'|trans }}</th>
                <th class="text-center">{{ 'quantity'|trans }}</th>
            </tr>
            </thead>
            <tbody>
            {% for orgatyp, count in templateVars.orgaList %}
                <tr>
                    <td>{{ orgatyp }}</td>
                    <td class="text-right u-pr">{{ count }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>

        <h2 class="u-mt-2">
            {{ 'user.roles'|trans }}
        </h2>

        <table class="c-table">
            <colgroup>
                <col>
                <col class="width-40">
            </colgroup>
            <thead>
            <tr>
                <th>{{ 'roles'|trans }}</th>
                <th class="text-center">{{ 'quantity'|trans }}</th>
            </tr>
            </thead>
            <tbody>
            {% for role, count in templateVars.rolesList %}
                <tr>
                    <td>{{ role }}</td>
                    <td class="text-right u-pr">{{ count }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>

        {% set statementStats = templateVars.statementStatistic %}
        {% set procedureCount = statementStats.totalAmountOfProcedures %}

        {% set procedurePhasesPublicAgencies = [] %}
        {% for internalPhase in templateVars.internalPhases %}
            {% set procedurePhasesPublicAgencies = procedurePhasesPublicAgencies|merge([{ key: internalPhase.name, value: internalPhase.num|default(0) }]) %}
        {% endfor %}

        {% set procedurePhasesPublic = [] %}
        {% for externalPhase in templateVars.externalPhases %}
            {% set procedurePhasesPublic = procedurePhasesPublic|merge([{ key: externalPhase.name, value: externalPhase.num|default(0) }]) %}
        {% endfor %}

        {# Find the best fitting colorScheme for a given number of phases (which are different across projects).
           At the moment, the highest number of phases is 15 (bobhh), so this has to be adapted if phases are added.
           Since a color scheme with more than 11 steps is not accessible anymore, for this edge case the 11-step
           scheme is expanded to use the same colors in reverse order above step 11.
           In a future iteration, we have to find a better way of displaying that data, since for > 10 phases
           it is not understandable at first glance. #}
        {% set colorScheme = {
            3: [ 'c-chart__color-3-1', 'c-chart__color-3-2', 'c-chart__color-3-3' ],
            6: [ 'c-chart__color-6-1', 'c-chart__color-6-2', 'c-chart__color-6-3', 'c-chart__color-6-4', 'c-chart__color-6-5', 'c-chart__color-6-6' ],
            8: [ 'c-chart__color-8-1', 'c-chart__color-8-2', 'c-chart__color-8-3', 'c-chart__color-8-4', 'c-chart__color-8-5', 'c-chart__color-8-6', 'c-chart__color-8-7', 'c-chart__color-8-8' ],
            15: [ 'c-chart__color-11-1', 'c-chart__color-11-2', 'c-chart__color-11-3', 'c-chart__color-11-4', 'c-chart__color-11-5', 'c-chart__color-11-6', 'c-chart__color-11-7', 'c-chart__color-11-8', 'c-chart__color-11-9', 'c-chart__color-11-10', 'c-chart__color-11-11', 'c-chart__color-11-10', 'c-chart__color-11-9', 'c-chart__color-11-8', 'c-chart__color-11-7' ]
        } %}
        {% set phases = procedurePhasesPublicAgencies|length %}
        {% set chartColorSchemeIndexPublicAgencies = [3, 6, 8, 15]|reduce((acc, val) => (val - phases)|abs <= (acc - phases)|abs ? val : acc, 1) %}
        {% set phases = procedurePhasesPublic|length %}
        {% set chartColorSchemeIndexPublic = [3, 6, 8, 15]|reduce((acc, val) => (val - phases)|abs <= (acc - phases)|abs ? val : acc, 1) %}

        {% if hasPermission('feature_procedure_report_public_phase') %}
            <div class="layout box-shadow-1 u-pv flow-root u-m u-mt-2">
                <div class="u-pl u-pr text-center">
                    <h2 class="u-mb-2 text-left">
                        {{ 'procedures.phase.overview'|trans }}
                    </h2>
                    <div>
                        <div class="u-5-of-12 u-1-of-1-palm u-mr inline-block">
                            <h4 class="text-left weight--bold">
                                {{ 'procedure.by.phase.invitable_institutions'|trans({ count: 0 }) }}
                            </h4>
                            <div
                                id="procedurePhasesPublicAgencies"
                                class="c-chart__svg-wrapper"
                                data-status="{{ procedurePhasesPublicAgencies|default([])|json_encode }}"
                                data-colors="{{ colorScheme[chartColorSchemeIndexPublicAgencies]|json_encode }}"
                                data-texts="{{ {
                                    'no-data-fallback': 'procedures.none'|trans,
                                    'legend-headline':'procedure.by.phase.invitable_institutions'|trans({ count: procedureCount }),
                                    'data-names': 'procedures'|trans,
                                    'data-name': 'procedure'|trans
                                }|json_encode }}">
                            </div>
                            <div id="procedurePhasesPublicAgenciesLegend" class="text-left"></div>
                        </div>
                        <div class="u-5-of-12 u-1-of-1-palm u-ml inline-block">
                            <h4 class="text-left weight--bold">
                                {{ 'procedure.by.phase.public'|trans({ count: 0 }) }}
                            </h4>
                            <div
                                id="procedurePhasesPublic"
                                class="c-chart__svg-wrapper"
                                data-status="{{ procedurePhasesPublic|default([])|json_encode }}"
                                data-colors="{{ colorScheme[chartColorSchemeIndexPublic]|json_encode }}"
                                data-texts="{{ {
                                    'no-data-fallback' : 'procedures.none'|trans,
                                    'legend-headline' : 'procedure.by.phase.public'|trans({ count: procedureCount }),
                                    'data-names' : 'procedures'|trans,
                                    'data-name' : 'procedure'|trans
                                }|json_encode }}">
                            </div>
                            <div class="text-left" id="procedurePhasesPublicLegend"></div>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}

        {% set statementAmountData = [
            {
                key: 'citizens.registered'|trans,
                value: statementStats.totalAmountOfCitizenStatements|default(0)
            },
            {
                key: 'guests'|trans,
                value: statementStats.totalAmountOfGuestStatements|default(0)
            },
            {
                key: 'invitable_institutions'|trans,
                value: statementStats.totalAmountOfInstitutionStatements|default(0)
            }
        ] %}

        {% set statementsAmountTotal = statementStats.totalAmountOfStatements|default(0) %}
        {% set statementsAverageTotal = statementStats.averageAmountOfStatementsPerProcedure|default(0) %}
        {% set statementAverageData = [
            {
                key: 'citizens.registered'|trans,
                value: statementStats.averageAmountOfCitizenStatementsPerProcedure|default(0)
            },
            {
                key: 'guests'|trans,
                value: statementStats.averageAmountOfGuestStatementsPerProcedure|default(0)
            },
            {
                key: 'invitable_institutions'|trans,
                value: statementStats.averageAmountOfInstitutionStatementsPerProcedure|default(0)
            }
        ] %}

        <div class="layout box-shadow-1 u-pv flow-root u-m u-mt-2">
            <div class="u-pl u-pr text-center">
                <h2 class="{{ statementsAmountTotal > 0 ? 'u-mb-2' : 'u-mb' }} text-left">
                    {{ 'statements.submitted.heading'|trans }}
                </h2>

                {% if hasPermission('feature_statement_move_to_procedure') %}
                    <p>{{ 'explanation.statistics.moved.statements'|trans }}</p>
                {% endif %}

                {% if statementsAmountTotal > 0 %}
                    <div>
                        <div class="u-1-of-3 u-1-of-1-palm u-mr-2 inline-block">
                            <h4 class="text-left weight--bold">
                                {{ 'procedures.in.all'|trans }}
                            </h4>
                            <div
                                id="statementsAmountChart"
                                class="c-chart__svg-wrapper"
                                data-status="{{ statementAmountData|default([])|json_encode }}"
                                data-colors="{{ colorScheme[3]|json_encode }}"
                                data-texts="{{ {
                                    'legend-headline': 'procedures.statements.total'|trans({ statementCount: statementsAmountTotal, procedureCount: procedureCount }),
                                    'data-names': 'statements'|trans,
                                    'data-name': 'statement'|trans
                                }|json_encode }}">
                            </div>
                            <div id="statementsAmountChartLegend" class="text-left"></div>
                        </div>
                        <div class="u-ml-2 u-1-of-3 u-1-of-1-palm inline-block">
                            <h4 class="text-left weight--bold">
                                {{ 'average.per.procedure'|trans }}
                            </h4>
                            <div
                                id="statementsAverageChart"
                                class="c-chart__svg-wrapper"
                                data-status="{{ statementAverageData|default([])|json_encode }}"
                                data-colors="{{ colorScheme[3]|json_encode }}"
                                data-texts="{{ {
                                    'legend-headline' : 'procedure.statements.average'|trans({ count: statementsAverageTotal }),
                                    'data-names' : 'statements'|trans,
                                    'data-name' : 'statement'|trans
                                }|json_encode }}">
                            </div>
                            <div class="text-left" id="statementsAverageChartLegend"></div>
                        </div>
                    </div>
                {% else %}
                    <div class="text-left">
                        {{ 'statements.none'|trans }}
                    </div>
                {% endif %}
            </div>
        </div>

        <div>
            <h2 class="u-mt-2 inline-block u-mr-0_5">{{ "procedures.list"|trans }}</h2>
            {% if hasPermission('feature_statement_move_to_procedure') %}
                <p>{{ 'explanation.statistics.moved.statements'|trans }}</p>
            {% endif %}

            <i class="fa fa-download btn-icns-icon"></i>
            <a class="btn-icns btn-left " href="{{ path('DemosPlan_statistics_csv',{'part': 'procedure' }) }}">
                {{ 'export'|trans }}
            </a>
        </div>

        <table class="c-table">
            <colgroup>
                <col class="width-10p">
                <col>
                <col class="width-20p">
                <col class="width-20p">
                <col class="width-5p">
                <col class="width-5p">
                <col class="width-5p">
            </colgroup>
            <thead>
                <tr>
                    <th scope="col" rowspan="2">{{ 'agencies'|trans }}</th>
                    <th scope="col" rowspan="2">{{ 'procedure'|trans }}</th>
                    <th scope="col" colspan="2">{{ 'procedure.public.phase'|trans }}</th>
                    <th scope="col" colspan="3">{{ 'statements'|trans }}</th>
                </tr>
                <tr>
                    <th scope="col">{{ 'invitable_institutions'|trans }}</th>
                    <th scope="col">{{ 'public'|trans }}</th>
                    <th scope="col">{{ 'invitable_institutions'|trans }}</th>
                    <th scope="col">{{ 'citizens.registered'|trans }}</th>
                    <th scope="col">{{ 'guests'|trans }}</th>
                </tr>
            </thead>
            <tbody>
            {% for item in templateVars.procedureList %}
                <tr>
                    <td class="o-hellip--td">
                        {{- item.orgaName -}}
                        {%- if item.planningOffices is defined -%}
                            /<br>
                            {%- for planningOffice in item.planningOffices -%}
                                {{ planningOffice.name }}
                            {%- endfor -%}
                        {%- endif -%}
                    </td>
                    <td class="o-hellip--td">
                        {{- item.name -}}
                        <br>
                        {{- 'from.date'|trans }}
                        {{ item.createdDate|default()|dplanDate -}}
                    </td>
                    <td class="o-hellip--td">
                        {{- item.phaseName|default() -}}
                        <br>
                        {{- item.startDate|default()|dplanDate -}}
                        -
                        {{- item.endDate|default()|dplanDate -}}
                    </td>
                    <td class="o-hellip--td">
                        {{- item.publicParticipationPhaseName|default() -}}
                        <br>
                        {{- item.publicParticipationStartDate|default()|dplanDate -}}
                        -
                        {{- item.publicParticipationEndDate|default()|dplanDate -}}
                    </td>
                    <td class="o-hellip--td">
                        {{- item.statementStatistic.amountOfToebStatementsOfProcedure -}}
                    </td>
                    <td class="o-hellip--td">
                        {{- item.statementStatistic.amountOfCitizenStatementsOfProcedure -}}
                    </td>
                    <td class="o-hellip--td">
                        {{- item.statementStatistic.amountOfGuestStatementsOfProcedure -}}
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>

        <h2 class="u-mt-2">
            {{ 'organisationsanduser'|trans }}
        </h2>

        <i class="fa fa-download btn-icns-icon"></i>
        <a class="btn-icns btn-left " href="{{ path('DemosPlan_statistics_csv',{'part': 'organisation' }) }}">
            {{ 'export'|trans }}
        </a>

        {% set fields = [
            { field: 'organisation', label: 'organisation'|trans ~ ' / ' ~ 'email.participation'|trans },
            { field: 'user', label: 'user.name'|trans ~ ' / ' ~ 'user.logon'|trans },
            { field: 'role', label: 'role.s'|trans }
        ] %}
        {% set items = [] %}

        {% for cnt in templateVars.orgaUsersList %}
            {% set itemFields = {} %}
            {% if cnt.users|length > 0 %}
                {% for user in cnt.users %}
                    {# set orga name #}
                    {% set orgaVal = cnt.organisation.nameLegal|default('') %}
                    {% if cnt.organisation.email2 is defined and cnt.organisation.email2|length > 0 %}
                        {% set orgaVal = orgaVal ~ '\n' ~ cnt.organisation.email2 %}
                    {% endif %}
                    {% set itemFields = itemFields|merge({ 'organisation': orgaVal }) %}

                    {# set name / username #}
                    {% set userVal = user.firstname|default ~ ' ' ~  user.lastname|default ~ '\n' ~ user.login|default %}
                    {% set itemFields = itemFields|merge({ 'user': userVal }) %}

                    {% set roleVal = '' %}
                    {% for role in user.roles|default([]) %}
                        {% if role == 'RMOPSA' %}
                            {% set roleVal = roleVal ~ "role.fpa"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RMOPSD' %}
                            {% set roleVal = roleVal ~ "role.fpsb"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RMOPPO' %}
                            {% set roleVal = roleVal ~ "role.fppb"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RPSOCO' %}
                            {% set roleVal = roleVal ~ "role.tbko"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RPSODE' %}
                            {% set roleVal = roleVal ~ "role.tbsb"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RTSUPP' %}
                            {% set roleVal = roleVal ~ "role.supp"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RTEDIT' %}
                            {% set roleVal = roleVal ~ "role.editor"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RCITIZ' %}
                            {% set roleVal = roleVal ~ "role.citizen"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RMOPSM' %}
                            {% set roleVal = roleVal ~ "role.fpmu"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RCOMAU' %}
                            {% set roleVal = roleVal ~ "role.cmu"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RDATA' %}
                            {% set roleVal = roleVal ~ "role.data"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RMOPHA' %}
                            {% set roleVal = roleVal ~ "role.haa"|trans ~ '\n' %}
                        {% endif %}
                        {% if role == 'RMOHAW' %}
                            {% set roleVal = roleVal ~ "role.haw"|trans ~ '\n' %}
                        {% endif %}
                    {% endfor %}
                    {% set itemFields = itemFields|merge({ 'role': roleVal }) %}
                    {% set items = items|merge([itemFields]) %}
                {% endfor %}
            {% endif %}
        {% endfor %}
    {% endapply %}

    {# table for organisations and users #}
    <dp-data-table-extended
        track-by="user"
        is-sortable
        :header-fields="JSON.parse('{{ fields|json_encode|e('js', 'utf-8') }}')"
        :table-items="JSON.parse('{{ items|json_encode|e('js', 'utf-8') }}')">
    </dp-data-table-extended>

{% endblock %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundles(['d3.js','admin-statistics.js']) }}
{% endblock javascripts %}
